/*
	To Build on UNIX type the following line.

	cc ZoomAnywhere.c -O4 -o ZACGI
*/

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#include <fcntl.h>

#ifdef WIN32
#include <io.h>
#endif


void SendErrorMessage(char *i_message);


int main(void) 
{	
	char *tempPtr = NULL;
	char fileName[4096];
	char queryString[4096];
	char tempString[4096];
	char *token = NULL;
	char *delims = "&=";
	long begin, end;
	char data[500*1024],extension[4];
	long bytesRead,result,dataSize;
	int fileNameLen;
	FILE *file = NULL;

	//get the parameters
	tempPtr =  (char*)getenv( "QUERY_STRING" );
	strcpy(queryString, tempPtr);
	token = strtok(queryString, delims);
	while(token)
	{
		if(!strcmp(token,"file"))
		{
			token = strtok(NULL, delims);
			if(token==NULL) 
			{
				SendErrorMessage("Error: 'file' parameter not defined!");
				return 0;
			}
			strcpy(fileName,token);
		}
		else if(!strcmp(token,"begin"))
		{
			token = strtok(NULL, delims);
			if(token==NULL) 
			{
				SendErrorMessage("Error: 'begin' parameter not defined!");
				return 0;
			}
			begin=atoi(token);
		}
		else if(!strcmp(token,"end"))
		{
			token = strtok(NULL, delims);
			if(token==NULL) 
			{
				SendErrorMessage("Error: 'end' parameter not defined!");
				return 0;
			}
			end=atoi(token);
		}

		token = strtok(NULL, delims);
	}
	
	//A little security...very little
	fileNameLen=strlen(fileName);
	extension[0]=tolower(fileName[fileNameLen-3]);
	extension[1]=tolower(fileName[fileNameLen-2]);
	extension[2]=tolower(fileName[fileNameLen-1]);
	extension[3]=0;

	if(strcmp(extension,"pff") != 0) 
	{
		SendErrorMessage("Error: Not a pff file!");
		return 0;
	}


	//check the size of the data
	dataSize=end - begin;
	if(dataSize <=0) 
	{
		SendErrorMessage("Error: Datasize less than or equal to zero!");
		return 0;
	}

	if(dataSize >= 500 * 1024) 
	{
		SendErrorMessage("Error: Datasize greater that 16k!");
		return 0;
	}


	//open the file
	file = fopen(fileName,"rb");
	if(file == NULL) 
	{
		sprintf(tempString, "Error:  Could not open file: %s", fileName);
		SendErrorMessage(tempString);
		return 0;
	}

	//seek into the file
	result = fseek(file,begin,SEEK_SET);
	if(result != 0) 
	{
		sprintf(tempString, "Error:  Could not seek file.");
		SendErrorMessage(tempString);
		return 0;
	}

	
	//read the data
	bytesRead = fread(data, dataSize, 1, file);
	if(bytesRead == 0) 
	{
		sprintf(tempString, "Error:  Could not read data from the file.");
		SendErrorMessage(tempString);
		return 0;
	}
	fclose(file);
	

	//write out the data
#ifdef WIN32
	result = _setmode( _fileno( stdout ), _O_BINARY );
#endif
	printf("Content-type: image/jpeg\n\n");  /* MIME html directive */
	fwrite(data,dataSize,1,stdout);

	return 0;
}


void SendErrorMessage(char *i_message)
{

	printf("Content-type: text/plain\n\n");  /* MIME html directive */
	printf(i_message);
}

//http://127.0.0.1/testza/zacgi.exe?file=Final1.pff&begin=92615&end=93896